#include <AFMotor.h>

byte receivedData;
int initDist;
bool countEnabled = true;

AF_DCMotor motor1(1, MOTOR12_2KHZ); 
AF_DCMotor motor2(2, MOTOR12_2KHZ); 
AF_DCMotor motor3(3, MOTOR12_2KHZ); 
AF_DCMotor motor4(4, MOTOR12_2KHZ);

void setup() {
  Serial.begin(9600);
}

void loop() {
  //moveForward();
  if(Serial.available() > 0){
    receivedData = Serial.read();
    if(receivedData == 'F'){
      /*for (int i = 65; i <= 90; i++) {
        Serial.print((char)i);
        delay(50);
      }*/
      /*Serial.print("Speed Check");
      Serial.println(); */
      moveForward();
      countEnabled = true;
    } else if(receivedData == 'B'){
      /*Serial.print("Back Check");
      Serial.println();*/
      moveBackward();
      countEnabled = true;
    } else if(receivedData == 'R'){
      /*Serial.print("Right Check");
      Serial.println();*/
      moveRight();
      countEnabled = true;
    } else if(receivedData == 'L'){
      /*Serial.print("Left Check");
      Serial.println();*/
      moveLeft();
      countEnabled = true;
    } else if(receivedData == 'Z'){
      /*Serial.print("Back Right Check");
      Serial.println();*/
      backRight();
      countEnabled = true;
    }  else if(receivedData == 'X'){
      /*Serial.print("Back Left Check");
      Serial.println();*/
      backLeft();
      countEnabled = true;
    } else if(receivedData == 'S'){
      /*Serial.print("Stop Check");
      Serial.println();*/
      stop();
      countEnabled = false;
    }
  }

  //This code is where I want to send the initDist value to appear on the application 
  if (countEnabled) {
    if (receivedData == 'F' || receivedData == 'R' || receivedData == 'L') {
      initDist += 1;
    } else if (receivedData == 'B' || receivedData == 'Z' || receivedData == 'X') {
      initDist -= 1;
    }

    Serial.print(initDist);
    Serial.println();
    delay(1000);
  }
}

void moveForward(){
  speed();
  motor1.run(BACKWARD);
  motor2.run(BACKWARD);
  motor3.run(FORWARD);
  motor4.run(FORWARD);
}

void moveBackward(){
  speed();
  motor1.run(FORWARD);
  motor2.run(FORWARD);
  motor3.run(BACKWARD);
  motor4.run(BACKWARD);
}

void moveRight(){
  speed();
  motor1.run(BACKWARD);
  motor2.run(BACKWARD);
  motor3.run(RELEASE);
  motor4.run(RELEASE);
}

void backRight(){
  speed();
  motor1.run(FORWARD);
  motor2.run(FORWARD);
  motor3.run(RELEASE);
  motor4.run(RELEASE);
}

void moveLeft(){
  speed();
  motor1.run(RELEASE);
  motor2.run(RELEASE);
  motor3.run(FORWARD);
  motor4.run(FORWARD);
}

void backLeft(){
  speed();
  motor1.run(RELEASE);
  motor2.run(RELEASE);
  motor3.run(BACKWARD);
  motor4.run(BACKWARD);
}

void stop(){
  motor1.run(RELEASE);
  motor2.run(RELEASE);
  motor3.run(RELEASE);
  motor4.run(RELEASE);
}

void speed(){
  motor1.setSpeed(255);
  motor2.setSpeed(255);
  motor3.setSpeed(255);
  motor4.setSpeed(255);
}